# Mill.jl (Multiple Instance Learning Library)

[`Mill.jl`](https://github.com/CTUAvastLab/Mill.jl) is a library built on top of [`Flux.jl`](https://fluxml.ai) aimed to flexibly prototype *hierarchical multiple instance learning* models as described in [Mandlik2021](@cite), [Pevny2018a](@cite) and  [Pevny2018b](@cite). It is developed to be:

* **flexible** and **versatile**
* as **general** as possible
* **fast** 
* and dependent on only handful of other packages

Watch our [`introductory talk`](https://www.youtube.com/watch?v=Bf0CvltIDbE) from JuliaCon 2021.

Go to

* [Motivation](@ref) for a brief introduction into the philosophy of `Mill`
* [Manual](@ref Nodes) for a brief tutorial into `Mill`
* [Examples](@ref Musk) for some examples of `Mill` use
* [External tools](@ref HierarchicalUtils.jl) to see examples of integration with other packages
* [Public API](@ref Aggregation) for an extensive API reference
* [References](@ref) for related literature
* [Citation](@ref) for preferred citation entries

## Installation

Run the following in REPL:

```julia
] add Mill
```

Julia v1.6 or later is required.
